<template>
  <v-main>
    <v-navigation-drawer app clipped hide-overlay>
      <v-list>
        <v-list-item>
          <v-list-item-content>
            <v-list-item-title class="text-h6">
              Control Panel
            </v-list-item-title>
          </v-list-item-content>
        </v-list-item>
      </v-list>
      <v-divider></v-divider>
    </v-navigation-drawer>

    <v-app-bar app clipped-left color="primary">
      <v-toolbar-title>PSVA Control Panel</v-toolbar-title>
    </v-app-bar>
    <v-alert type="error" color="danger" v-if="!isConnected">
      <v-row no-gutters>
        <v-col cols="17">
          Can't open socket to server, socket currently not connected! </v-col
        ><v-col cols="1">
          <v-btn color="primary" @click="init" depressed outlined
            >try again</v-btn
          >
        </v-col>
      </v-row></v-alert
    >
    <v-alert type="warning" v-if="!gotAdditionalPanels">
      <v-row no-gutters>
        <v-col cols="17">
          Request to fetch user-defined panels failed. Panels may be defined,
          but not displayed here. This is likely a server-side problem. </v-col
        ><v-col cols="1">
          <v-btn
            color="primary"
            @click="data.gotAdditionalPanels = true"
            depressed
            outlined
            >dismiss</v-btn
          >
        </v-col>
      </v-row></v-alert
    >
    <v-container>
      <v-toolbar>
        <v-toolbar-title>PSVA Streaming Control Panel</v-toolbar-title>
        <v-spacer></v-spacer>
        <v-btn
          :color="
            data.statusVA.running && data.statusSignalingServer.running
              ? 'danger'
              : 'success'
          "
          :loading="data.statusVA.loading || data.statusSignalingServer.loading"
          :disabled="
            data.statusVA.loading || data.statusSignalingServer.loading
          "
          @click="
            data.statusVA.running && data.statusSignalingServer.running
              ? stopAll()
              : startAll()
          "
          >{{
            data.statusVA.running && data.statusSignalingServer.running
              ? "Stop"
              : "Start"
          }}</v-btn
        >
      </v-toolbar>
    </v-container>
    <v-container>
      <v-expansion-panels v-model="data.openPanels" multiple>
        <v-expansion-panel :disabled="data.useUEaudio">
          <v-expansion-panel-header
            :disable-icon-rotate="
              data.statusVA.running ||
              data.statusVA.error ||
              data.statusVA.loading
            "
          >
            VA Server
            <template
              v-slot:actions
              v-if="
                data.statusVA.running ||
                data.statusVA.error ||
                data.statusVA.loading
              "
            >
              <v-icon v-if="data.statusVA.loading">mdi-loading mdi-spin</v-icon>
              <v-icon v-else-if="data.statusVA.error" color="danger">
                mdi-alert-circle
              </v-icon>
              <v-icon v-else-if="data.statusVA.running" color="success">
                mdi-check
              </v-icon>
            </template>
          </v-expansion-panel-header>
          <v-expansion-panel-content>
            <v-alert color="danger" type="error" v-if="data.statusVA.error">{{
              data.statusVA.errorText
            }}</v-alert>
            <v-btn
              :loading="data.statusVA.loading"
              :disabled="data.statusVA.loading"
              :color="data.statusVA.running ? 'danger' : 'success'"
              @click="data.statusVA.running ? stopVA() : startVA()"
              >{{ data.statusVA.running ? "Stop" : "Start" }}</v-btn
            >
            <v-textarea
              readonly
              background-color="grey"
              v-model="data.statusVA.consoleText"
            >
            </v-textarea>
          </v-expansion-panel-content>
        </v-expansion-panel>

        <v-expansion-panel>
          <v-expansion-panel-header
            :disable-icon-rotate="
              data.statusSignalingServer.running ||
              data.statusSignalingServer.error ||
              data.statusSignalingServer.loading
            "
          >
            Signalling Server
            <template
              v-slot:actions
              v-if="
                data.statusSignalingServer.running ||
                data.statusSignalingServer.error ||
                data.statusSignalingServer.loading
              "
            >
              <v-icon v-if="data.statusSignalingServer.loading"
                >mdi-loading mdi-spin</v-icon
              >
              <v-icon
                v-else-if="data.statusSignalingServer.error"
                color="danger"
              >
                mdi-alert-circle
              </v-icon>
              <v-icon
                v-else-if="
                  data.statusSignalingServer.running &&
                  !data.statusSignalingServer.error
                "
                color="success"
              >
                mdi-check
              </v-icon>
            </template>
          </v-expansion-panel-header>
          <v-expansion-panel-content>
            <v-alert
              color="danger"
              type="error"
              v-if="data.statusSignalingServer.error"
            >
              {{ data.statusSignalingServer.errorText }}
            </v-alert>
            <v-row>
              <v-col cols="1">
                <v-btn
                  :loading="data.statusSignalingServer.loading"
                  :disabled="data.statusSignalingServer.loading"
                  :color="
                    data.statusSignalingServer.running ? 'danger' : 'success'
                  "
                  @click="
                    data.statusSignalingServer.running
                      ? stopSignalingServer()
                      : startSignalingServer()
                  "
                  >{{
                    data.statusSignalingServer.running ? "Stop" : "Start"
                  }}</v-btn
                >
              </v-col>
              <v-col>
                <v-switch
                  v-model="data.useUEaudio"
                  :label="data.useUEaudio ? 'using UE audio' : 'using VA audio'"
                  color="danger"
                  style="margin-top: 0em; padding-left: 1em"
                  @click="switchAudioPipeline"
                ></v-switch>
              </v-col>
            </v-row>
            <v-textarea
              readonly
              background-color="grey"
              v-model="data.statusSignalingServer.consoleText"
            >
            </v-textarea>
          </v-expansion-panel-content>
        </v-expansion-panel>
        <v-expansion-panel>
          <v-expansion-panel-header
            >VA Autio WebRTC Stream</v-expansion-panel-header
          >
          <v-expansion-panel-content>
            <v-alert
              color="danger"
              type="error"
              v-if="data.statusAudioStream.error"
            >
              {{ data.statusAudioStream.errorText }}
            </v-alert>
            <v-list>
              <v-list-item v-for="call in data.calls" :key="call.id">
                <v-list-item-title>{{ call.id }}</v-list-item-title>
                <v-list-item-action>
                  <v-btn
                    :color="call.active ? 'danger' : 'success'"
                    @click="
                      call.active ? closeCall(call) : connectToNewPeer(call.id)
                    "
                    >{{ call.active ? "Close" : "Call" }}</v-btn
                  >
                </v-list-item-action>
              </v-list-item>
            </v-list>
          </v-expansion-panel-content>
        </v-expansion-panel>

        <v-expansion-panel disabled>
          <v-expansion-panel-header
            :disable-icon-rotate="
              data.statusGame.running ||
              data.statusGame.error ||
              data.statusGame.loading
            "
          >
            Unreal Engine Project
            <template
              v-slot:actions
              v-if="
                data.statusGame.running ||
                data.statusGame.error ||
                data.statusGame.loading
              "
            >
              <v-icon v-if="data.statusGame.loading"
                >mdi-loading mdi-spin</v-icon
              >
              <v-icon v-else-if="data.statusGame.error" color="danger">
                mdi-alert-circle
              </v-icon>
              <v-icon
                v-else-if="data.statusGame.running && !data.statusGame.error"
                color="success"
              >
                mdi-check
              </v-icon>
            </template>
          </v-expansion-panel-header>
          <v-expansion-panel-content>
            <v-alert color="danger" type="error" v-if="data.statusGame.error">{{
              data.statusGame.errorText
            }}</v-alert>
            <v-btn
              :loading="data.statusGame.loading"
              :disabled="data.statusGame.loading"
              :color="data.statusGame.running ? 'danger' : 'success'"
              @click="startGame"
              >{{ data.statusGame.running ? "Stop" : "Start" }}</v-btn
            >
            <v-textarea
              readonly
              background-color="grey"
              v-model="data.statusGame.consoleText"
            >
            </v-textarea>
          </v-expansion-panel-content>
        </v-expansion-panel>
        <v-expansion-panel
          v-for="panel in data.additionalPanels"
          :key="panel.id"
        >
          <v-expansion-panel-header>{{ panel.title }}</v-expansion-panel-header>
          <v-expansion-panel-content>
            {{ panel.body }}
            <v-textarea
              readonly
              background-color="grey"
              v-model="panel.command"
            >
            </v-textarea>
          </v-expansion-panel-content>
        </v-expansion-panel>
      </v-expansion-panels>
    </v-container>
  </v-main>
</template>

<script lang="ts">
import Vue from "vue";
import axios from "axios";
import { Peer } from "peerjs";
import { io } from "socket.io-client";

import {
  socketResponse,
  serverStateResponse,
  Call,
  allData,
} from "../interfaces/interfaces";

export default Vue.extend({
  name: "HomeView",
  components: {},
  mounted() {
    this.init();
  },
  data() {
    const data: allData = {
      openPanels: [],
      additionalPanels: [],
      gotAdditionalPanels: false,
      socket: undefined,
      peer: undefined,
      stream: undefined,
      useUEaudio: false,
      calls: [],
      statusAll: false,
      statusVA: {
        loading: false,
        running: false,
        consoleText: "",
        error: false,
        errorText: "",
      },
      statusSignalingServer: {
        loading: false,
        running: false,
        consoleText: "",
        error: false,
        errorText: "",
      },
      statusAudioStream: {
        loading: false,
        running: false,
        consoleText: "",
        error: false,
        errorText: "",
      },
      statusGame: {
        loading: false,
        running: false,
        consoleText: "",
        error: false,
        errorText: "",
      },
    };

    return { data: data };
  },
  computed: {
    isConnected: function (): boolean {
      return this.data.socket ? this.data.socket.connected : false;
    },
    gotAdditionalPanels: function (): boolean {
      return this.data.gotAdditionalPanels;
    },
  },
  methods: {
    init: async function () {
      const currState = this.data;

      try {
        const savedStateResponse = await axios.get(
          "http://localhost:7273/api/get-saved-state"
        );

        const savedState: serverStateResponse = savedStateResponse.data;

        console.log("got: ");
        console.log(savedState);

        this.data.statusVA.loading = savedState.va.loading;
        this.data.statusVA.running = savedState.va.running;
        this.data.statusVA.consoleText = savedState.va.output;

        this.data.statusSignalingServer.loading = savedState.sserver.loading;
        this.data.statusSignalingServer.running = savedState.sserver.running;
        this.data.statusSignalingServer.consoleText = savedState.sserver.output;

        this.data.statusGame.loading = savedState.game.loading;
        this.data.statusGame.running = savedState.game.running;
        this.data.statusGame.consoleText = savedState.game.output;
      } catch {
        console.log("Couldn't restore state");
        this.data = currState;
      }

      try {
        const additionalPanels = await axios.get(
          "http://localhost:7273/api/get-additional-panels"
        );

        this.data.additionalPanels = additionalPanels.data;
        this.data.gotAdditionalPanels = true;
      } catch {
        this.data.additionalPanels = [];
      }

      this.data.socket = io("http://localhost:7273", {
        reconnection: false,
      });

      this.data.peer = new Peer();

      // DEBUG
      console.log(this.data.socket);

      //DEBUG
      /*
      this.data.socket.onAny((event: string, ...args: any) => {
        console.log(event, args);
      });
      */

      this.data.socket.on("newPeerID", (data: socketResponse) => {
        if (!data.id) {
          return;
        }

        this.connectToNewPeer(data.id);
      });

      this.data.socket.on("VA", (data: socketResponse) => {
        this.data.statusVA.consoleText += data.payload;

        if (data.type === "closed") {
          this.data.statusVA.running = false;
        }
      });

      this.data.socket.on("SSERVER", (data: socketResponse) => {
        this.data.statusSignalingServer.consoleText += data.payload;

        if (data.type === "closed") {
          this.data.statusSignalingServer.running = false;
        }
      });
    },
    connectToNewPeer: async function (id: string) {
      if (
        this.data.calls.filter((call) => {
          return call.id === id && call.active === true;
        }).length > 0
      ) {
        console.log("Returned early");
        return;
      }

      if (!this.data.stream) {
        try {
          this.data.stream = await navigator.mediaDevices.getUserMedia({
            video: false,
            audio: true,
          });
        } catch {
          this.data.stream = undefined;
          return;
        }
      }

      console.log("Making call now");

      const call = this.data.peer.call(id, this.data.stream);

      const callStatus = {
        id: id,
        active: true,
        call: call,
      };

      this.data.calls.filter((call) => {
        return call.id === id && call.active === false;
      }).length > 0
        ? this.data.calls
            .filter((call) => {
              return call.id === id && call.active === false;
            })
            .forEach((call) => {
              call.active = true;
            })
        : this.data.calls.push(callStatus);

      call.on("close", () => {
        call.close();
      });
    },
    closeCall: function (call: Call) {
      if (call.active) {
        call.call.close();
        call.active = false;
      }
    },
    startVA: function () {
      this.data.statusVA.consoleText = "";
      this.data.statusVA.loading = true;
      axios
        .post("http://localhost:7273/api/start-va/")
        .then((res) => {
          if (res.status === 200) {
            this.data.statusVA.running = true;
            this.data.statusVA.error = false;
            this.data.statusVA.errorText = "";
          } else {
            this.data.statusVA.running = false;
            this.data.statusVA.error = true;
            this.data.statusVA.errorText = `Recieved status code ${res.status} when trying to start VA Server`;
          }
          this.data.statusVA.loading = false;
        })
        .catch((err) => {
          this.data.statusVA.running = false;
          this.data.statusVA.error = true;
          this.data.statusVA.errorText = err;
          this.data.statusVA.loading = false;
        });
    },
    stopVA: function () {
      this.data.statusVA.loading = true;
      axios
        .post("http://localhost:7273/api/stop-va/")
        .then(() => {
          this.data.statusVA.running = false;
          this.data.statusVA.error = false;
          this.data.statusVA.errorText = "";
          this.data.statusVA.loading = false;
        })
        .catch((err) => {
          console.log(err);
          this.data.statusVA.loading = false;
        });
    },
    startSignalingServer: function () {
      this.data.statusSignalingServer.loading = true;
      this.data.statusSignalingServer.consoleText = "";
      axios
        .post("http://localhost:7273/api/start-signaling-server")
        .then((res) => {
          if (res.status === 200) {
            this.data.statusSignalingServer.running = true;
            this.data.statusSignalingServer.error = false;
            this.data.statusSignalingServer.errorText = "";
          } else {
            this.data.statusSignalingServer.running = false;
            this.data.statusSignalingServer.error = true;
            this.data.statusSignalingServer.errorText = `Recieved status code ${res.status} when trying to start SignalingServer`;
          }
          this.data.statusSignalingServer.loading = false;
        })
        .catch((err) => {
          this.data.statusSignalingServer.running = false;
          this.data.statusSignalingServer.error = true;
          this.data.statusSignalingServer.errorText = err;
          this.data.statusSignalingServer.loading = false;
        });
    },
    stopSignalingServer: function () {
      this.data.statusSignalingServer.loading = true;
      axios
        .post("http://localhost:7273/api/stop-signaling-server/")
        .then(() => {
          this.data.statusSignalingServer.running = false;
          this.data.statusSignalingServer.error = false;
          this.data.statusSignalingServer.errorText = "";
          this.data.statusSignalingServer.loading = false;
        })
        .catch((err) => {
          console.log(err);
          this.data.statusSignalingServer.loading = false;
        });
    },
    startGame: async function () {
      this.data.statusGame.loading = true;
      await axios.post("https://testlolkekjajetztecht.free.beeceptor.com", {
        name: "test",
      });
      this.data.statusGame.loading = false;
    },
    stopAll: function () {
      this.stopVA();
      this.stopSignalingServer();
    },
    startAll: function () {
      this.data.openPanels = [0, 1];
      this.startVA();
      this.startSignalingServer();
    },
    switchAudioPipeline: async function () {
      if (this.data.useUEaudio) {
        this.data.openPanels = [1];

        this.stopVA();
        this.stopSignalingServer();

        const res = await axios.post(
          "http://localhost:7273/api/switch-audio-pipeline",
          { pipeline: "UE" }
        );
      }
      console.log(1);
    },
  },
});
</script>
